REM ***************************************************
REM *   I N V A S O R E S   A Q U A T I C O S  2.0    *
REM *                                                 *
REM *         Jogo escrito por Marco & Tito           *
REM *       publicado em "Mini Micro's", N. 12        *
REM * Adaptação para ZX Basic por ESPECTROTEAM, 2018. *
REM ***************************************************

#include <attr.bas> 

SUB FASTCALL halt(wait AS UBYTE)
  ASM
    PROC
    LOCAL loop
    LD B,A
    loop: HALT
    DJNZ loop
    ENDP
  END ASM
END SUB

RANDOMIZE

REM constantes
MAXSUBM = 16
LOST = "     OS INVASORES VENCERAM"
WIN  = "    VITORIA! SALVOU A TERRA!"

REM \{vi}INVASORES AQUATICOS\{vn}*Jo-go escrito por Marco & Tito, pu-blicado em "Mini Micro's", N. 12
FOR be=-20 TO 60: BEEP .008,be: NEXT be: BORDER 7: PAPER 7: CLS
i=RND*6: PRINT AT 0,0; INK i;"\{vi}                                \{vn}";AT 21,0; INK i;"\{vi}                                \{vn}";AT 2,4; INK 2; FLASH 1;"INVASORES AQUATICOS 2.0"
PRINT AT 4,0; INK 1;"   NESTE JOGO,  OS INVASORES IN-TERPLANETARIOS RESOLVEM ATACAR ONOSSO PLANETA PELO MAR.";AT 7,0; INK 1;"   CABE  A  SI  DEFENDER A TERRADESTA PRAGA. A BASE AQUATICA TEMTRES PODEROSOS EJECTORES DE TOR-PEDOS (TECLAS 1-2-3)  QUE SERVI-RAO PARA DESTRUIR  OS SUBMARINOSINVASORES."
PRINT AT 13,0; INK 1;"   QUANDO  DEIXAR  PASSAR  CERTONUMERO DE  SUBMARINOS,  IMPECA ANAVE-MAE DE DESTRUIR A TERRA. HALIMITE DE TORPEDOS. CUIDADO!"
PRINT AT 18,6; INK i; FLASH 1; BRIGHT 1;"TECLE";AT 18,12; INK 4; FLASH 0;"para jogar.>>": PAUSE 0: CLS
GOSUB udgs: DIM b AS FLOAT: Dim p AS UINTEGER
DIM tor AS INTEGER
 
startGame:
PAPER 1: BORDER 3
INK 9
CLS
DIM ff AS FLOAT: b=0.0: FOR f=0 TO 21: ff=f/7: PRINT AT f,0; INK ff; PAPER 9;"\::";AT f,31;"\::"
NEXT f: INK 7
PRINT AT 0,1;"\g\h \g\h \g\h \g\h \g\h  \g\h \g\h \g\h \g\h \g\h"
PRINT AT 4,6;INK 4;"\p\q\r";AT 5,6;INK 4;"\s\t\u"
PRINT AT 3,15;INK 4;"\g\h"

PRINT AT 6,21;INK 4;"\g";INK 2; PAPER 6; BRIGHT 1; "\j"
PRINT AT 7,22;"\m";AT 8,22; INK 6; BRIGHT 1;"\n"

PRINT AT 10,4;"INVASORES AQUATICOS 2.0"
PRINT AT 12,3;INK 4;"\g\h"
PRINT AT 15,7;"\m";AT 16,7; INK 6; BRIGHT 1;"\n"

PRINT AT 13,15;"\m";AT 14,15; INK 6; BRIGHT 1;"\n"
PRINT AT 17,23;INK 4;"\g\h"
PRINT AT 20,4;"Original por Marco & Tito"
PRINT AT 21,1;"Adaptado por ESPECTROTEAM 2018"
PRINT AT 22,0; PAPER 3;"                                                            "
PRINT AT 23,0; PAPER 3;"\: \: \: \: \: \: \: TECLE PARA COMECAR\ :\ :\ :\ :\ :\ :\ :"
PAUSE 0: CLS
PRINT AT 22,0; PAPER 3;"                                                            "
PRINT AT 23,0; PAPER 3;"                                                            "
a=INT (RND*10)+3
t=0
tor=10: p=0
n=0:
PRINT AT 0,0; INK 5;"\{vi}                                                                \{vn}"
PRINT AT 2,0; PAPER 5; INK 1;"\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o\o"
PRINT AT 21,0; INK 3;"\b\a\c\d\e\f\a\b\c\i\b\a\d\e\f\a\a\b\a\b\e\i\b\d\e\f\a\b\c\a\e\f"
GOSUB printStats

REM ciclo principal
DO
    IF tor >0 AND NOT t AND INKEY$="1" THEN x=4: GOSUB launchTor: END IF
    IF tor >0 AND NOT t AND INKEY$="2" THEN x=15: GOSUB launchTor: END IF
    IF tor >0 AND NOT t AND INKEY$="3" THEN x=27: GOSUB launchTor: END IF
    
    IF t THEN 
        PRINT AT y,x;"\m";AT y+1,x; INK 6; BRIGHT 1;"\n";AT y+2,x; PAPER 1; INK 7; BRIGHT 0;" "
        IF ATTR (y-1,x)=12 THEN 
            ' explosion
            IF n<MAXSUBM THEN
                GOSUB submExplosion
            ELSE
                GOSUB alienExplosion
                GOTO endGame
            END IF
            GOSUB printStats
            b=0: a=INT (RND*10)+3
            PRINT AT y,x;" ";AT y+1,x;" ": t=0
        END IF
        y=y-1
        IF y=2 THEN 
            PRINT AT y+1,x;" ";AT y+2,x;" ": t=0
        END IF
    END IF
    
    IF n<MAXSUBM THEN PRINT AT a,b;" "; INK 4;"\g\h": b=b+0.15*((RND*2)+1): END IF
    
    IF b>29.5 AND n<MAXSUBM THEN
        PRINT AT a,INT b+1;"  ": n=n+1
        GOSUB printRemainingSubs
        b=0: a=INT (RND*10)+3
        IF n=MAXSUBM THEN 
            ' alien
            PRINT AT y+1,x;" ";AT y+2,x;" ": t=0
            BEEP 1,-10: 
        END IF
    END IF

    IF n=MAXSUBM THEN
        PRINT AT 10,b;INK 7;" ";INK 4;"\p\q\r";AT 11,b;INK 7;" ";INK 4;"\s\t\u": BEEP .05,RND*40
        b=b+1
        IF b=29 THEN m$ = LOST: GOTO endGame: END IF
    END IF

    halt(1)
LOOP

endGame:
a=0: FOR f=0 TO 10
BEEP .1,-12+a: BORDER 0
BEEP .1,12+a: BORDER 4
a=a+3: NEXT f
PRINT AT 10,0;m$;AT 11,0;"        \jFIM\j\jDE\j\jJOGO\j"
FOR a=0 TO 10: BEEP .01,a
BEEP .01,-a: NEXT a: PAUSE 100
PAUSE 0
GOTO startGame

launchTor:
PRINT AT 21,x;"\k": BEEP .04,-6
PRINT AT 21,x;"\l": BEEP .04,12
PRINT AT 21,x;"\e";AT 20,x; INK 7;"\m": BEEP .04,24
PRINT AT 19,x; INK 7;"\m";AT 20,x; INK 6; BRIGHT 1;"\n": BEEP .04,48
tor = tor -1
GOSUB printStats
y=18: t=1
RETURN

submExplosion:
PRINT AT y+1,x;" ";AT y,x;" ": FOR f=7 TO 1 STEP -1
FOR g=0 TO 7: PRINT AT y-1,x-1; PAPER f; INK g;"\j\j\j"
OUT 254,16: OUT 254,0
NEXT g: NEXT f
PRINT AT y-1,x-1;"   "
BORDER 3
p=p+10
tor=tor+2
IF tor > 99 THEN
    tor = 99
END IF
IF n > 0 THEN
    n=n-1
END IF
GOSUB printRemainingSubs
RETURN

alienExplosion:
PRINT AT y+1,x;" ";AT y,x;" "
FOR i=0 TO 4
    FOR f=7 TO 1 STEP -1
        FOR g=0 TO 7: PRINT AT 10,b; PAPER f; INK g;"\j\j\j"
            PRINT AT 11,b; PAPER f; INK g;"\j\j\j"
            OUT 254,16: OUT 254,0
        NEXT g
    NEXT f
NEXT i
PRINT AT 10,b;"    "
PRINT AT 11,b;"    "
p=p+500
GOSUB printStats
m$ = WIN
RETURN

printStats:
PRINT AT 1,1;"PONTOS ";p: PRINT AT 1,20;"TORPEDOS "
IF tor < 10 THEN 
    PRINT AT 1,29;"0";tor
ELSE
    PRINT AT 1,29;tor
END IF
RETURN

printRemainingSubs:
IF n > 0 THEN
    FOR i = 1 TO n
        PRINT AT 23,(i*2-2);INK 4; PAPER 3;"\g\h"
    NEXT i
    IF n<MAXSUBM THEN
        PRINT AT 23,n*2;PAPER 3;"  "
    END IF
ELSE
    PRINT AT 23,0;PAPER 3;"  "
END IF
RETURN

udgs:
POKE UINTEGER 23675, @graphics
RETURN
graphics:
ASM
DEFB 000,000,000,000,016,062,063,255 ; A
DEFB 000,000,000,000,000,003,239,255 ; B
DEFB 000,000,000,000,000,240,254,255 ; C
DEFB 000,008,012,030,062,063,127,255 ; D
DEFB 000,000,000,000,000,034,221,255 ; E
DEFB 000,016,048,048,120,124,255,255 ; F
DEFB 000,000,003,158,255,254,143,001 ; G
DEFB 056,032,248,196,226,242,254,252 ; H
DEFB 000,000,000,062,071,139,171,255 ; I
DEFB 000,126,126,126,126,126,126,000 ; J
DEFB 000,008,008,042,085,213,255,255 ; K
DEFB 008,008,020,085,093,201,255,255 ; L
DEFB 008,008,020,020,028,008,028,028 ; M
DEFB 000,020,020,020,008,008,008,000 ; N
DEFB 000,000,000,000,000,000,059,228 ; O
DEFB 000,000,000,129,143,254,127,143 ; P
DEFB 060,126,195,169,020,000,060,255 ; Q
DEFB 000,000,000,129,241,127,254,241 ; R
DEFB 208,122,047,097,067,230,165,231 ; S
DEFB 126,129,119,036,024,036,024,000 ; T
DEFB 011,094,244,131,194,103,165,231 ; U
END ASM
